## libatomicbitvector 0.0+git20200519.e295358

=== CMakeLists.txt ===
# Specify the minimum version for CMake

cmake_minimum_required(VERSION 3.1)

# Project's name
project(atomicbitvector)

# We build using c++14
set(CMAKE_CXX_STANDARD 14)

# Use all standard-compliant optimizations
set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -O3 -g")
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3 -g")

if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")

  # assumes clang build
  # we can't reliably detect when we're using clang, so for the time being we assume
  # TODO: can't we though?
  
  # adapted from https://stackoverflow.com/questions/46414660/macos-cmake-and-openmp
  # find_package(OpenMP) does not work reliably on macOS, so we do its work ourselves
  set (OpenMP_C "${CMAKE_C_COMPILER}")
  set (OpenMP_C_FLAGS " -Xpreprocessor -fopenmp -I/opt/local/include/libomp -I/usr/local/include -L/opt/local/lib/libomp -L/usr/local/lib")
  set (OpenMP_C_LIB_NAMES "libomp" "libgomp" "libiomp5")
  set (OpenMP_CXX "${CMAKE_CXX_COMPILER}")
  set (OpenMP_CXX_FLAGS " -Xpreprocessor -fopenmp -I/opt/local/include/libomp -I/usr/local/include -L/opt/local/lib/libomp -L/usr/local/lib")
  set (OpenMP_CXX_LIB_NAMES "libomp" "libgomp" "libiomp5")
  set (OpenMP_libomp_LIBRARY "omp")
  set (OpenMP_libgomp_LIBRARY "gomp")
  set (OpenMP_libiomp5_LIBRARY "iomp5")
  
  # and now add the OpenMP parameters to the compile flags
  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
  set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${OpenMP_EXE_LINKER_FLAGS} -lomp")
  
elseif (${CMAKE_SYSTEM_NAME} MATCHES "Linux")

  find_package(OpenMP REQUIRED)
  
  # add the flags it detects to the compile flags
  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS} -fopenmp")
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS} -fopenmp")
  set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${OpenMP_EXE_LINKER_FLAGS}")
  
endif()

# Set the output folder where your program will be created
set(CMAKE_BINARY_DIR ${CMAKE_SOURCE_DIR}/bin)
set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR})
set(LIBRARY_OUTPUT_PATH ${CMAKE_SOURCE_DIR}/lib)

# The following folder will be included
include_directories("${PROJECT_SOURCE_DIR}")

#set(CMAKE_BUILD_TYPE Release)
set(CMAKE_BUILD_TYPE Debug)

# set up our target executable and specify its dependencies and includes
#add_library(atomicbitvector_objs OBJECT
#  ${CMAKE_SOURCE_DIR}/src/x...
#  )

#add_dependencies(bdsg_objs ${bdsg_DEPS})

set(atomicbitvector_INCLUDES
  "${CMAKE_SOURCE_DIR}/include")

add_executable(test_atomicbitvector
  ${CMAKE_SOURCE_DIR}/src/main.cpp)
target_include_directories(test_atomicbitvector PUBLIC ${atomicbitvector_INCLUDES})

if (APPLE)
elseif (TRUE)
  if (BUILD_STATIC)
    set(CMAKE_EXE_LINKER_FLAGS "-static")
  endif()
endif()

=== debian/changelog ===
libatomicbitvector (0.0+git20200519.e295358-4) unstable; urgency=medium

  * Team upload.

  [ Michael R. Crusoe ]
  * d/rules: use DEB_BUILD_OPTION_PARALLEL instead of nproc to respect
    Debian Policy 4.9.1.

  [ Étienne Mollier ]
  * d/control: declare compliance to standards version 4.7.2.
  * d/control: drop redundtant Rules-Requires-Root: no.
  * d/watch: convert to watch file v5.
  * cmake-4.patch: new: bump minimum cmake to 3.10. (Closes: #1113113)

 -- Étienne Mollier <emollier@debian.org>  Wed, 01 Oct 2025 20:00:25 +0200

libatomicbitvector (0.0+git20200519.e295358-3) unstable; urgency=medium

  * Fix clean target
    Closes: #1047857
  * Standards-Version: 4.6.2 (routine-update)
  * Set upstream metadata fields: Repository-Browse.
  * Apply multi-arch hints.
    + libatomicbitvector-dev: Add Multi-Arch: foreign.

 -- Andreas Tille <tille@debian.org>  Fri, 12 Jan 2024 07:13:26 +0100

libatomicbitvector (0.0+git20200519.e295358-2) unstable; urgency=medium

  * Remove trailing whitespace in debian/copyright (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit.

 -- Andreas Tille <tille@debian.org>  Thu, 11 Jun 2020 21:59:05 +0200

libatomicbitvector (0.0+git20200519.e295358-1) unstable; urgency=medium

  * Initial release (Closes: #962233)

 -- Andreas Tille <tille@debian.org>  Thu, 04 Jun 2020 22:48:07 +0200

=== debian/control ===
Source: libatomicbitvector
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>
Section: libdevel
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/med-team/libatomicbitvector
Vcs-Git: https://salsa.debian.org/med-team/libatomicbitvector.git
Homepage: https://github.com/ekg/atomicbitvector

Package: libatomicbitvector-dev
Architecture: all
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: atomic bitset/bitvector with size determined at runtime
 This header-only library encodes a bitvector class with size fixed at
 runtime. Atomic operations allow for concurrent access and modification
 of the bitset. Such a structure can help with coordinating parallel
 processing of a given fixed set of entities, and has the advantage of
 only requiring O(1) bit per entry.
 .
 The atomic_bv_t class is a straightforward extension of ConcurrentBitSet
 from Facebook's folly C++ library. It wraps the atomic type with a class
 that allows them to be copied, and these wrapped atomic types are then
 used to build a vector whose size is determined at runtime.

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1
export LC_ALL=C.UTF-8

include /usr/share/dpkg/default.mk
# this provides:
# DEB_SOURCE: the source package name
# DEB_VERSION: the full version of the package (epoch + upstream vers. + revision)
# DEB_VERSION_EPOCH_UPSTREAM: the package's version without the Debian revision
# DEB_VERSION_UPSTREAM_REVISION: the package's version without the Debian epoch
# DEB_VERSION_UPSTREAM: the package's upstream version
# DEB_DISTRIBUTION: the distribution(s) listed in the current entry of debian/changelog
# SOURCE_DATE_EPOCH: the source release date as seconds since the epoch, as
#                    specified by <https://reproducible-builds.org/specs/source-date-epoch/>

# for hardening you might like to uncomment this:
# export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@

### When overriding auto_test make sure DEB_BUILD_OPTIONS will be respected
override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	bin/test_atomicbitvector 10000000 $(DEB_BUILD_OPTION_PARALLEL)
endif

=== debian/watch ===
Version: 5

Source: https://github.com/ekg/atomicbitvector.git
Matching-Pattern: HEAD
Mode: git
Git-Pretty: 0.0+git%cd.%h
